
\begin{figure*}
\centering
\includegraphics[scale=.78]{workflow/EnhancedRandoop}
\caption{The workflow of guided random testing (GRT), which combines information from static analysis with run-time guidance.
%During the initial static testing phase,  constants are extracted from program under test by Constant mining
%Constant mining + impurity => more diverse input, 
%Detective + improve more testing method => more objects, 
%Elephant brain => diverse object types, uncover more program states
%Orienteering, accelerate the testing speed, 
%Bloodhound, 
%The overall design of GRT considers guiding each step of test generation~(i.\,e. \emph{method\ selection})
%by the domain knowledge gathered by its six components that work collaboratively, 
%static analysis and dynamic analysis~(run-time) of the program under test
%6 component work collaboratively 
%each test generation step make use of such domain  knowledge automatically extracted by 6 component collaboratively
%automatically gather 
}\label{fig:enhanced-randoop}
\end{figure*}

\section{Our Approach}
\label{sec:enhancements}

%We have devised six enhancements to Randoop. They are based on information 
%gathered from a static analysis prior to running the main tool,
%and at run-time when generating tests (see Fig.~\ref{fig:enhanced-randoop}).
%The information is used to guide Randoop. We briefly define a term
%to denote each enhancement and describe them in detail below.

GRT leverages \emph{domain knowledge}
gathered from the program under test to guide each step of random test generation.
Such domain knowledge is automatically extracted and used by its six main collaborative 
components that perform static and dynamic analysis as testing progresses~(see Fig.~\ref{fig:enhanced-randoop}):
% is based on information gathered from static
%analysis and dynamic analysis of the program under test, so that 
%each step of test generation can leverage such information to guide random
%testing to work effectively.

\begin{enumerate}
\item \emph{Constant mining} (static): Constants are extracted from classes under test to seed the main object pool. 
	   The mined constants are also used as input for specific methods.
%	   at run-time input selection. 
	   \item \emph{Impurity} (static + run-time): Impurity performs purity analysis for all MUTs statically. 
At run-time, it further fuzzes the inputs selected from the object pool based on Gaussian distribution and purity analysis results before using them to test an MUT.
% to test an MUT are fuzzed based on Gaussian distribution and purity analysis results before feeding to the MUT.
\item \emph{Elephant brain} (run-time): Method sequences~(to create inputs) in the object pool are managed with the exact types obtained at run-time \emph{result\ evaluation}~(see Fig.~\ref{fig:enhanced-randoop}).
%This increases the input object type diversity so that an seemly missing input object for an MUT in the object pool managed by static type can still be found if the exact type information is used. This also equips other components 
%like Impurity and Detective with the exact type information to improve their overall effects.
\item \emph{Detective} (static + run-time): Detective analyzes the method input and return type dependency statically, 
	and constructs missing input data on demand at run-time.
%Detective helps to construct necessary object that cannot be created from a fixed MUT pool.
%The usage of a secondary object pool does not cause additional pressure on the main object pool and
%caches all additional objects that help to speed up further unavailable objects construction.
%Detective conquers the limitation of a fixed method pool effectively and benefits all other components.
\item \emph{Orienteering} (run-time): Method sequences that require lower cost to execute are favored.
%This causes the testing speed acceleration effect all the other components.
\item \emph{Bloodhound} (run-time): Method selection and sequence generation is guided by coverage information at 
run-time.
%to favor methods whose code is not well covered. 
%Covering more code of an MUT reaches more program states, which
%potentially facilitate to create more diverse state objects to cover more code.
\end{enumerate}

Although each of the six main components of GRT can function individually, they
are designed to collaborate with each other to be more effective.
%Constant mining improves the diversity of initial object pool by feeding extracted constants.
%It facilitates to create more diverse objects from the mined constants.
%It helps to cover more branches and further facilitates the whole test generation by creating more diverse objects.
%\footnote{Many non-primitive objects are constructed based on primitive values at run-time.}
%Constant mining and method sequence execution help Impurity to work more effectively.
% creates objects with more diverse states through fuzzing and uses the altered objects as inputs to test an MUT.
Impurity boosts the effect of Constant ming through input fuzzing.
%The state fuzzing can be more effectively directed on the top of extracted constants from Constant mining.
Elephant brain further diversifies the input object types so that a seemingly 
missing input object for an MUT in the static type managed object pool can still be found if the exact type information is used.
It also equips other components like Impurity and Detective with the exact type information to improve their overall effectiveness.
Detective constructs necessary objects that cannot be created from original fixed MUT pool by demand.
%It constructs such objects by demand in a secondary object pool and cache them there so as to speed up
%unavailable objects construction in later phase.
%uses a secondary object pool and does not cause additional pressure on the main object pool, where
%all additionally created objects by demand are also cached in the secondary object pool that helps to speed up further unavailable objects construction.
It overcomes the limitation of a fixed MUT pool and all other components can benefit from the effect
that additional methods are covered and more objects for inputs are created.
Orienteering accelerates the overall testing speed of GRT and makes the effect of the other components more apparent. 
Bloodhound intelligently favors to select an MUT not well covered.
Upon covering more code of an MUT, more program states are reached, which
potentially facilitates to create more diverse objects to cover even more code.
The rest of this section presents each component in detail.


\subsection{Automatic Constant Extraction}
Simple constant values of primitive types are often used by random
testing techniques to create complex objects at a bottom up way. A straightforward strategy
is to generate these values at random, but it may lead to low code coverage.
Consider the example from class \texttt{PatternOptionBuilder} in 
Fig.~\ref{fig:constant-m}: Branches of method \texttt{getValueClass}
are not covered by Randoop as it does not start with the required
predefined primitive values, and is unable to derive the right values 
from them to satisfy these branch conditions at run-time.
Although manual constant selection may cover such branches~(e.\,g. as an option in Randoop), 
it requires much human effort to gather suitable values and has scalability issues with larger software.

Various automatic techniques are proposed to remedy this shortcoming.
Symbolic execution~\cite{Visser:2004:TIG:1013886.1007526,
Luckow:2014:SPV:2557833.2560571} and concolic
testing~\cite{Godefroid:2005:DDA:1064978.1065036,Sen:2005:CCU:1095430.1081750}
solve symbolic constraints to derive inputs that cover more branches.
%Unfortunately, symbolic execution is slow and does not deal well with
%complex branch conditions and nested data structures.
Adaptive Random Testing~(ART) 
~\cite{Chen:2004:ART:2105774.2105800,Ciupa:2008:AAR:1368088.1368099}
searches for values from the whole
input domain based on a predefined distribution~(e.\,g., uniform distribution).
However, the input construction of ART often requires additional overhead, which
can limit ART to larger real-world software that need complex inputs~\cite{Arcuri:2011:ART:2001420.2001452,Park:2012:CAH:2393596.2393636}.
%the input domain space is usually still quite large~(e.\,g., for a branch condition
%comparing string values), which limits the effectiveness of ART on practical software~\cite{Arcuri:2011:ART:2001420.2001452,Park:2012:CAH:2393596.2393636}.(++update this seems to be dangerous to claim,
%as discussed by An orchestrated survey of methodologies for automated software test case generation)


To obtain relevant input values without incurring too much overhead,
we perform a lightweight static analysis, called \emph{constant mining}, 
on the classes under test. Our key observation is that constant
values are more likely to be useful as test inputs if they are used in the 
program under test.
%For example, branch conditions such as the string comparison
%\texttt{str.equals("coverMe")} can be easily covered. 


Constant mining extracts constants from classes under test and performs constant propagation
and constant folding to further enrich the set of input values as
candidates for the value pool. The assumption is based on our observation that many of these values 
are close to satisfying some branch conditions.
%However, we found that simply seeding all the extracted constant to the object pool and
%randomly selecting them~(as inputs) to test a method with no distinction still has lower chance to cover specific branches, 
%because practical software usually contains large number of constants. 
However, we found that simply selecting the extracted constants as inputs~(at random) with no distinction on methods
still has lower chance to cover specific branches, because practical software usually contains a large number of constants
and a constant may only be relative to a few specific branches.
Therefore, we use the extracted constants in two levels:~a global level~(among all
classes) and a local level~(a constant is only used for the class that contains it).

%To further improve over a uniform selection of extracted values as inputs,
We give a weight for each extracted value for its global selection as
inputs for all classes. The weight is computed based on a modified version of
term frequency-inverse document frequency~(TF-IDF), which is usually used
to measure the important of a term in a set of documents~\cite{Manning:2008:IIR:1394399}. 
In the context of constant mining, we treat each class as a document and 
each extracted constant as a term assigned a weight ${\mathrm{tf\mbox{-}idf}_v}(t,D)=$
\[\mathrm{tf}(t,D) * \mathrm{idf}(t,D)=\mathrm{tf}(t,D) * \log\frac{|D|+1}{|D|+1 - |{d \in D: t\in d}|}
\]
In this formula, $\mathrm{tf}(t,D)$ represents the frequency of a constant
$t$ occurring in all classes $D$, where $|D|$ is
the total number of classes in the program under test, and $|{d \in D: t\in d}|$ 
is the number of classes that contain the constant $t$.
We favor a constant if it is used more frequently and in more classes.

Besides using these constants globally among all classes, we also register the
extracted constants for each class containing it, and
select such constants probabilistically~(with an empirical probability of 1\,\%)
as inputs for an MUT of the corresponding class at run-time.
To obtain even more relevant values, we also use state fuzzing (see Section~\ref{subsec:fuzzing}).

%in Section~\ref{subsec:fuzzing} . 

%Our tool for extracting constants is based on ASM~\cite{Bruneton02asm:a}.
%We implement our abstract interpreter on top of the ASM interpreter framework~\cite{Bruneton02asm:a}, which
%analyzes the Java bytecode of each class under test 
%and performs constant propagation and folding.
%Our analysis is intra-procedural;
%we forgo a more accurate inter-procedural and pointer analysis
%for performance reasons. Using value propagation, our approach goes
%beyond value extraction from source code~\cite{conf/kbse/RobinsonEPAL11}.

\subsection{Purity-Based Object State Fuzzing}
\label{subsec:fuzzing}

%Adaptive random testing approach reduces such limitations by generating constant based
%on some probability distribution. However, the high cost of input object construction limits such an approach only 
%to small libraries. Adaptive random testing does not use the domain knowledge of CUT, resulting some branch conditions
%difficult to be covered. 
Covering a specific path of an MUT requires certain states of the receiver and 
the input argument objects. 
In order to generate sequences with a broad variety of object states,
we randomly alter (or \emph{fuzz}) the states of the input objects and 
pass the fuzzed results to the MUT.
%Our fuzzing is activated in 30\,\% of all cases when choosing an input;
We handle primitive numbers based on a Gaussian distribution and
non-primitive objects based on method purity analysis.

\subsubsection{Primitive Value Fuzzing}
Primitive inputs are either extracted by 
constant mining or from run-time execution results.
To cover a wider range of inputs, we use a heuristic: given values are already 
close to satisfying some of the branch conditions.
When a primitive number $c$ is selected as an input, we adopt a Gaussian distribution 
to probabilistically fuzz its value and use the altered result as input.
Specifically, we use the original value of $c$ and a predefined constant as the 
expectation~(mean) value $\mu$ and deviation $\sigma$, respectively.
%\footnote{In our current setting we fixed $\sigma=30$.}
This approach gives higher probabilities to values closer to $\mu$~(68.3\,\% 
of fuzzed values probabilistically lie in $[ \mu-\sigma, \mu + \sigma]$),
while still generating values distant from $\mu$.
For primitive value fuzzing, we empirically select $\sigma=30$ as the 
deviation for Gaussian distribution fuzzing. 

To fuzz a string value, we randomly perform operations of string manipulation, 
including inserting a character, removing a character, replacing a character, 
and taking a substring on the given string.
%This allows us to obtain a wider range of
%primitive values based on information extracted from the classes under test.


%The Levenshtein distance~\cite{levenshtein1966bcc}
%is adopted for generating string values.

%To prevent newly generated primitive values from
%polluting our object pool, we do not store values obtained from fuzzing; 
%we only add new values that are
%observed during execution.

%This allows us to obtain a wider range of
%primitive values based on information extracted from the classes under test.
%We implement our primitive value fuzzer based on the elementary
%distance~\cite{Ciupa:2008:AAR:1368088.1368099} to generate 
%values. 


\subsubsection{Purity-Analysis-Based Object State Fuzzing}

To increase the coverage of branches and execution
paths, objects are required to be in diverse states.
We fuzz non-primitive objects to increase their state diversity by identifying and using methods that have side
effects that alter the state of the receiver instance, method parameters, or (global) static fields.

Method purity analysis~\cite{Salcianu:2005:PSE:2131753.2131773} classifies
MUTs into pure and impure methods. Methods without side effects are \emph{pure},
and methods with side effects are \emph{impure}. 
Only impure methods can change the state of an object~\cite{Salcianu:2005:PSE:2131753.2131773}.
While invoking pure methods is useful to peek object states, 
selecting such methods often creates long and redundant sequences which 
make object states stay unchanged, slowing down overall growth of coverage.
Therefore, impure methods should be favored over pure methods in order 
to frequently mutate object states to satisfy more branch conditions.

%If these methods also depend on an input object of another type, we look up the type from existing generated sequences and give up fuzzing if some input is unavailable. Our approaches fuzzes the
%input object into more diverse states so that more branch conditions
%can be satisfied.
%We focus on method \emph{impurity} for fuzzing input object states.
Static~\cite{Salcianu:2005:PSE:2131753.2131773,Tschantz:2005:JAR:1094811.1094828,Huang:2012:RRC:2398857.2384680}
and dynamic~\cite{Zeller:JPURE2007,Xu:2007:DPA:1251535.1251548}
purity analysis techniques and tools exist.
We choose a static technique~\cite{Huang:2012:RRC:2398857.2384680} to avoid additional overhead at run-time.

%For each selected input MUT from the previously generated sequences,
%we randomly decide whether to fuzz the object
%states before using that sequence.
%
%Our approach handles objects of primitive values and non-primitive  
%values differently. For primitive numbers, we fuzz the input value by using Gaussian distributions, where the input value
%is used as the expectation $\mu$.
%For string values, we randomly fuzz
%some of its characters, remove parts of the string, or extend it with
%another randomly generated strings.
%For the non-primitive objects, we randomly select those methods that
%mutate the input object state.


\begin{figure}
\centering
\lstinputlisting[firstnumber=1,stepnumber=5,numberfirstline]{src-example/MotivatingExample.java}
\caption{Two classes from \emph{Apache CLI.}\label{fig:constant-m}
Branch coverage requires both domain knowledge on constant values
and accurate type management.}
\end{figure}

\begin{figure}
\centering
\lstinputlisting[firstnumber=1,stepnumber=5,numberfirstline]{src-example/IOUtils.java}
\caption{Methods in \emph{Compress} require inputs outside
the fixed method pool.\label{fig:compress-m}}
\end{figure}

\subsection{Dynamic Input Sequence Management}
\label{subsec:dynamic_management}
Subtyping is pervasive in object-oriented programs. If the exact
type of an object $o$ cannot be determined statically, it is safe to use the static 
(declared) return type of the method that returns $o$.
However, this assumption causes some methods never to be tested, 
because no type-compatible input can be found, even if a sequence that 
returns the required type at run-time does exist.
%This limitation of using only static types may result from the need to 
%easily generate compilable code for off-line testing, which requires the 
%correct type casts to be added if the dynamic type of a variable does not 
%correspond to its static type.

In the example shown in Fig.~\ref{fig:constant-m}, branch coverage in method
\texttt{createVal} requires both
suitable primitive values and a class descriptor returned by
\texttt{getValueClass} method. However, static type management stores
the object returned by \texttt{getValueClass} as type \texttt{Object}
according to its declaration. This results in \texttt{createVal} never
being directly tested.

To improve the effectiveness of input object selection,
we manage the object pool~(see Fig.~\ref{fig:enhanced-randoop}), 
which contains all successfully executed method sequence that could return objects as 
further input to test MUTs, by using the exact return type of each method sequence 
obtained at run-time. Our approach easily covers previously non-covered
methods that depend on the exact type information of its input.

%~(due to the subtype relation,
%in cases where the exact type is cast to its super class and not remembered
%by default Randoop).

When outputting the generated sequences as test cases, we also
compare the static type of each method with its dynamic type, adding
explicit type casts where necessary. Without type casts,
the generated test code may fail to compile, because the static types
of method parameters~(including the receiver) 
do not match the dynamic types of the objects passed to them.

The dynamic type management identifies many diverse data types and never forgets;
we therefore call it \emph{elephant brain}.



%\subsection{Fixed Method Pool}
%Randoop uses a fixed method pool when considering methods to test.
%However, many methods require an input type that cannot
%be generated from invoking a fixed set of API methods;
%instead, they may require data from libraries not belonging to the software
%under test itself.
%When a method requires an input type that cannot be generated
%from existing input sequences, Randoop simply skips that method.
%Because of this, many MUTs are never tested.%
%%\footnote{Some of these methods
%%may still be indirectly invoked from other methods that are directly tested.}
%

%\subsection{Lengthy Input Sequences}
%Randoop manages all generated successful sequences in its object pool 
%such that sequences that return the same type are put into the same set. 
%Whenever an input with a specific type is required, Randoop randomly selects
%a sequence among all available sequences.
%Since new sequences are constructed by concatenating existing input
%sequences, the resulting sequences can grow considerably in length.
%This adds to the execution cost of generated test cases.
%Randoop quickly reaches a bottleneck after running for several minutes,
%repeatedly executing lengthy sequences while leaving many other
%relevant sequence combinations untested.
%
%
%\subsection{No Coverage-Based Guidance}
%The difficulty of covering a branch varies between branches. 
%Some branches are easily covered in the early phase of random
%testing, while others require a complex object state. An equally balanced 
%selection of methods to be tested, wastes time on those methods
%that are already well covered.
%On the other hand, too much emphasis on uncovered branches may
%waste time in challenging the difficult branches without much payoff.
%Our observation is that the current strategy of Randoop is not ideal,
%but the solution is not as simple as looking for uncovered 
%branches~\cite{Jaygarl:2010:GTG}.


\subsection{Demand-Driven Input Construction}
\label{subsec:detective}
To test an MUT, its receiver object and input arguments must be
prepared. Thus, the ability of creating objects that MUTs depend on
can greatly affect the number of testable MUTs. In order to create
such auxiliary objects, diverse API types and methods are often required.

Consider class \texttt{IOUtils} (see Fig.~\ref{fig:compress-m}), where
both methods \texttt{copy} and \texttt{skip}
require an object of type \texttt{InputStream}. However, the required
object is never
generated by tools like Randoop as it needs to use the Java core library.
As a result, no method of this class is ever covered.
%even though providing the required input easily covers most of these methods.

%Default Randoop skips a method if some input type is unavailable.

%Randoop only considers publicly visible methods and constructors from
%the classes under test for testing.
%However, this misses cases where a method of a different class
%or another library returns the right type.

Although it is tempting to use all accessible methods from as many classes
as possible, this greatly increases the search space
and wastes effort on methods that are not the target.
%and pollutes the object pool, wasting effort on methods that are not the target.

We make two improvements:
First, we analyze the type dependency of MUTs to identify those types
that cannot be created by running MUTs only. 
Second, we use a demand-driven approach to construct
inputs of types that are not directly available,
by maintaining a secondary object pool.

Our dependency analysis statically computes dependencies of MUTs 
by considering their input and return types.
Given two methods $m_1$ and $m_2$, $m_1$ depends on $m_2$ if $m_1$ requires an input type that can be returned by $m_2$. 
We compute this dependency information of all methods as a graph, where a method occurs as a node
and an edge represents the dependency relation between two methods. 
If a method does not depend on other MUTs and requires a non-primitive
input type, we determine that such an input type cannot be generated by
executing the current set of MUTs. 
Based on the dependency analysis, we 
only consider those unavailable inputs as candidates for demand-driven
input construction.

When an unavailable input is required during test generation,
we search all available packages for constructors and static methods 
that return the required type.
We recursively search further if more input is needed for a
candidate method that returns the sought-after type.
If methods to produce the required data are found,
we leverage a \emph{secondary object pool} 
to execute the methods and store the resultant objects.
The secondary object pool is only used for previously unavailable input types.
A sequence that returns a previously required input type is added to 
the main object pool, while other generated sequences remain
in the secondary object pool.
If further unavailable input is needed later, we first check the secondary object
pool before performing an expensive recursive search again.
%To reduce the overhead of the secondary object pool, we keep only
%one sequence for each type.
Our approach does not pollute the main object pool and provides more
input types with little overhead.

Like a \emph{detective}, this component works by following
clues (i.\,e., relationships) between methods.


\subsection{Cost-Guided Input Sequence Selection}
%Randoop manages generated method sequences by their return types.
%All sequences that return the same type are treated equally,
%regardless of their length and execution time.

In FRT, new sequences are often constructed 
by concatenating previously generated sequences as inputs, and the resulting sequences can grow 
considerably in length and execution cost.
%This increases the execution cost of generated test cases.
Even worse, repeatedly executing lengthy sequences may take up 
too much execution budget and leave many other relevant sequence 
combinations untested.

For better run-time performance,
it is desirable to use method sequences that have lower execution cost.
The idea is inspired by \emph{orienteering}, where a
path that takes lower cost is preferable.
Therefore, we select a sequence as an input based on its execution cost measured by:
%$\mathrm{weight}(\mathit{seq}) ={1}/{(\mathit{seq}.\mathit{exec\_time}* k)}$,
$\mathrm{weight}(\mathit{seq}) ={1}/{(\sum_{i=1}^{k}\mathit{seq}.\mathit{exec\_time_i}*\sqrt{\mathit{seq}.\mathit{meth\_size}})}$,
where $\mathit{seq}$ is a sequence for selection, $k$ counts how many times
$seq$ has been selected so far, $seq.exec\_time_i$
is the execution time during the $i$th execution of $seq$, and 
$\mathit{seq}.\mathit{meth\_size}$ is the number of methods in $\mathit{seq}$, excluding assignments of primitive values.
Selecting input sequences based on this weight formula favors shorter sequences with 
less execution time, in order to accelerate test generation and avoid wasting test budget
on lengthy and time-consuming sequences.

%As measuring and updating the execution time of each sequence
%incurs additional overhead, we measure the execution time of each sequence
%only once, expecting it not to change much.

\subsection{Coverage-Guided Method Selection}
\label{subsec:coverage}
The difficulty of covering a branch varies between branches. 
Some branches are easily covered in the early phase of random
testing, while others require complex object states. 
An equally balanced selection of MUTs wastes 
time on those methods that are already covered.
On the other hand, too much emphasis on non-covered branches may
waste time in challenging the difficult branches without much payoff.
%Our observation is that the current strategy of Randoop is not ideal,
%but the solution is not as simple as looking for uncovered 
%branches~\cite{Jaygarl:2010:GTG}.

To direct test execution towards uncovered code, we perform 
coverage analysis during test generation, and favor those MUTs
that are not well covered. 
Although it is desirable to update the coverage
information after executing each MUT, this is expensive;
method selection is executed frequently during test generation.
Therefore, the coverage information is updated at time interval $t$. 
During each interval, we prioritize method selection for a method $m$ among 
all MUTs $M$ by using the following function to compute its weight $w(m,k)$:

\vspace{-.75\baselineskip}
{\scriptsize
\[
  \begin{cases}
   \alpha*\mathrm{UncovRatio}(m)  + (1-\alpha)* \left(1-\cfrac{\mathrm{Succ}(m)}{\mathrm{MaxSucc}(M)}\right) & \text{if } k = 0 \\
  \mathrm{Max}(\left(\cfrac{-3}{\ln(1-p)}* \cfrac{p^k}{k}\right),\cfrac{1}{\ln(\mathrm{Size}(M)+3)}) *w(m,0)  & \text{if }  k\geq 1
%    \left(\cfrac{-3}{\ln(1-p)}* \cfrac{p^k}{k}\right)*\gamma*w(m,0)  + \cfrac{\delta}{\mathrm{Size}(M)}     & \text{if }  k\geq 1
  \end{cases}
\]
}
In this function, $k$ represents the number of selections of method $m$
since the last update of coverage information;
$\mathrm{UncovRatio}(m)$ is 
the uncovered branch ratio of $m$;
$p$ is the parameter of a logarithmic series that determines how fast
the factor decreases as $k$ increases;
$\mathrm{Succ}(m)$ is the total number of successful invocations of $m$;
$\mathrm{MaxSucc}(M)$ is the maximal number of successful invocations of
all MUTs; $\mathrm{Max}(a,b)$ returns the larger value of the two given values;
$\mathrm{Size}(M)$ is the number of MUTs $M$; and
$\alpha$ is the parameter to adjust the weight of the first formula.

The overall effect of the weight function is that initially ($k=0$) we favor 
those methods with low code coverage in selection for execution.
Once a method has been tested successfully ($ k\geq 1$), we downgrade its
weight logarithmically~(the first part of $\mathrm{Max}$ function).
After several rounds of selection, the weight of each method returns
to a uniform distribution again~(the second part of $\mathrm{Max}$ function).
At each update of the coverage, the weights 
are recalculated, and $k$ is reset to 0.

Our method selection strategy is inspired by the multi-armed bandit algorithm~\cite{Vermorel:2005:MBA:2130928.2130972}.
This algorithm balances
``exploitation'' (methods that are well tested) and ``exploration''
(methods with low coverage) for a higher payoff.
This algorithm is useful because some branches of an MUT can be difficult to cover
even if the MUT is tested over and over again.
A weight function only based on an uncovered ratio of code would waste
resources on those methods with difficult branch conditions
without gaining much benefit. 
Our approach considers both code coverage and the execution history
of each MUT for the initial weight, but decreases this weight later
to avoid investing too much effort in difficult branches.

Like a \emph{Bloodhound,} this enhancement hungers for coverage,
while intelligently balancing the deeper search
of each MUT against the breadth given by the entire problem set.
